/*-----------------------ADI ADF4350 Driver Test Code-----------------------------------

Author: 		ADI CAST (China Application Support Team)
Date:			2009-06-12
Rev:			V1.0
Description:	Realize ADF4350 DriverUse ADuC7026 as MCUADF4350 EVB as test bpard.
				Development Tool: KEIL C(version 3.24)
				Test program by reading and writing register of ADF4350

---------------------------------------------------------------------------------------------------------*/
#include <ADuC7026.h>
#include "ADF4350_IO.h"

unsigned	char	buf[4] = {0,0,0,0};

void putchar(unsigned char ch)/* Write character to Serial Port  */  
{          
	COMTX = ch;				 //COMTX is an 8-bit transmit register.
    while(!(0x020==(COMSTA0 & 0x020)))
    {;}
}

void ADuC7026_Initiate(void)
{
    //Clock Initial
    POWKEY1 = 0x01;				//Start PLL Setting
    POWCON = 0x00;				//Set PLL Active Mode With CD = 0  CPU CLOCK DIVIDER = 41.78MHz
    POWKEY2 = 0xF4;				//Finish PLL Setting

	GP1CON = 0x011;				  //PIN set up for UART
     


	GP4DAT = GP4DAT | 0x38000000; //Configure the P4.3 pin as output for LE of ADF4350, CS Stall Low
								  //Configure the P4.4 pin as output for SCLK of ADF4350, SCLK Stall Low
								  //Configure the P4.5 pin as output for DATA of ADF4350
   	//UART InitialBaud Rate = 9600								  	
	COMCON0 = 0x080;  
	COMDIV0 = 0x088;    		
	COMDIV1 = 0x000;
	COMCON0 = 0x007; 

}  
int main (void)
{ 
    ADuC7026_Initiate();

/*-------------------------------------200MHz---------------------------------------------
Reference frequency: 10MHz;Output frequency: 200MHz;VCO frequency: 3200MHz;Prescaler: 8/9;
Output divider: 16;VCO channel spacing frequency: 1600KHz;PFD frequency: 10MHz;
INT: 320;FRAC: 0;MOD: 6;R: 1;Clk Div: 80;Phase: 1
----------------------------------------------------------------------------------------*/

	buf[3] = 0x00;
	buf[2] = 0x58;
	buf[1] = 0x00;				//write communication register 0x00580005 to control the progress 
 	buf[0] = 0x05;				//to write Register 5 to set digital lock detector
	WriteToADF4350(4,buf);		

	buf[3] = 0x00;
	buf[2] = 0xC5;				//(DB23=1)The signal is taken from the VCO directly;(DB22-20:4H)the RF divider is 16;(DB19-12:50H)R is 80
	buf[1] = 0x00;				//(DB11=0)VCO powerd up;
 	buf[0] = 0x3C;				//(DB5=1)RF output is enabled;(DB4-3=3H)Output power level is 5
	WriteToADF4350(4,buf);		

	buf[3] = 0x00;
	buf[2] = 0x00;
	buf[1] = 0x04;				//(DB14-3:96H)clock divider value is 150.
 	buf[0] = 0xB3;
	WriteToADF4350(4,buf);	

	buf[3] = 0x00;
	buf[2] = 0x00;				//(DB6=1)set PD polarity is positive;(DB7=1)LDP is 6nS;
	buf[1] = 0x4E;				//(DB8=0)enable fractional-N digital lock detect;
 	buf[0] = 0xC2;				//(DB12-9:7H)set Icp 2.50 mA;
	WriteToADF4350(4,buf);		//(DB23-14:1H)R counter is 1

	buf[3] = 0x08;
	buf[2] = 0x00;
	buf[1] = 0x80;			   //(DB14-3:6H)MOD counter is 6;
 	buf[0] = 0x31;			   //(DB26-15:6H)PHASE word is 1,neither the phase resync 
	WriteToADF4350(4,buf);	   //nor the spurious optimization functions are being used
							   //(DB27=1)prescaler value is 8/9

	buf[3] = 0x00;
	buf[2] = 0xA0;
	buf[1] = 0x00;
 	buf[0] = 0x00;				//(DB14-3:0H)FRAC value is 0;
	WriteToADF4350(4,buf);		//(DB30-15:140H)INT value is 320;

/*-------------------------------------300MHz---------------------------------------------
Reference frequency: 10MHz;Output frequency: 300MHz;VCO frequency: 2400MHz;Prescaler: 8/9;
Output divider: 8;VCO channel spacing frequency: 800KHz;PFD frequency: 10MHz;
INT: 240;FRAC: 0;MOD: 12;R: 1;Clk Div: 80;Phase: 1
----------------------------------------------------------------------------------------*/

/*
	buf[3] = 0x00;
	buf[2] = 0x58;				//write communication register 0x00580005 to control the progress
	buf[1] = 0x00;				//to write Register 5 to set digital lock detector
 	buf[0] = 0x05;
	WriteToADF4350(4,buf);		

	buf[3] = 0x00;
	buf[2] = 0xB5;				//(DB23=1)The signal is taken from the VCO directly;(DB22-20:3H)the RF divider is 8;(DB19-12:50H)R is 80
	buf[1] = 0x00;				//(DB11=0)VCO powerd up;
 	buf[0] = 0x3C;				//(DB5=1)RF output is enabled;(DB4-3=3H)Output power level is 5
	WriteToADF4350(4,buf);		//(DB23-14:1H)R counter is 1

	buf[3] = 0x00;
	buf[2] = 0x00;
	buf[1] = 0x04;
 	buf[0] = 0xB3;
	WriteToADF4350(4,buf);		//(DB14-3:96H)clock divider value is 150.

	buf[3] = 0x00;
	buf[2] = 0x00;				//(DB6=1)set PD polarity is positive;(DB7=1)LDP is 6nS;
	buf[1] = 0x4E;				//(DB8=0)enable fractional-N digital lock detect;
 	buf[0] = 0xC2;				//(DB12-9:7H)set Icp 2.50 mA;
	WriteToADF4350(4,buf);		

	buf[3] = 0x08;
	buf[2] = 0x00;				//(DB14-3:CH)MOD counter is 12;
	buf[1] = 0x80;				//(DB26-15:6H)PHASE word is 1,neither the phase resync 
 	buf[0] = 0x61;				//nor the spurious optimization functions are being used
	WriteToADF4350(4,buf);		//(DB27=1)prescaler value is 8/9

	buf[3] = 0x00;
	buf[2] = 0x78;
	buf[1] = 0x00;
 	buf[0] = 0x00;				//(DB14-3:0H)FRAC value is 0;
	WriteToADF4350(4,buf);		//(DB30-15:F0H)INT value is 240;

*/
	while(1)
    {;}

}

